<template>
    <div class="page-container">
        <h3 class="mb-0">
            {{ title }} Discount Link
        </h3>
        <div>
            <div class="d-flex justify-content-end">
                <router-link
                    :to="{name: 'discount-links'}"
                    class="btn btn-primary btn_back"
                >
                    Back
                </router-link>
            </div>
        </div>
        <ValidationObserver
            ref="form"
        >
            <validation-element
                v-model="item.code"
                label="Code"
            />
            <validation-element
                v-model="item.discount"
                label="Discount"
            />
            <validation-element
                v-model="item.expires_at"
                label="Expires at"
                input-type="datetime-local"
            />
            <b-button
                variant="primary"
                type="button"
                @click="submit"
            >
                Submit
            </b-button>
        </ValidationObserver>
    </div>
</template>

<script>
import ValidationElement from '../elements/ValidationElement.vue'
export default {
  components: { ValidationElement },
  props: ['title', 'editItem'],
    data() {
        return {
            item: {
                id: null,
                code: '',
                discount: '',
                expires_at: '',
            },
        }
    },
    created() {
        if(this.editItem) {
            this.item.id = this.editItem.id
            this.item.code = this.editItem.code
            this.item.discount = this.editItem.discount
            this.item.expires_at = this.$formatter.dateFormat(this.editItem.expires_at, 'yyyy-MM-DD hh:mm')
        }
    },
    methods: {
        async submit() {
            const result = await this.$refs.form.validate()
            const valid =  await this.$refs.form
            if(result) {
                const item = Object.assign({}, this.item)
                item.expires_at = this.$formatter.dateFormatToISO(this.item.expires_at)
                this.$emit('submit',item)
                setTimeout(() => {
                    this.$refs.form.reset()
                }, 2000)
            } else this.getFormErrors(valid.errors)
            
        }
    }
}
</script>

<style lang="scss" scoped>
.btn {
  &_back {
    margin: 10px 0 10px auto;
  }
}
.page-container {
    padding-top: 40px;
    @media(max-width: 770px) {
        padding-top: 80px;
    }
}
</style>
